#include "Frage.h"
#include <Schrift.h>
#include <Text.h>
#include "../../../Initialisierung/Initialisierung.h"

// Konstructor
//  tr: Ein Zeiger auf die zu verwendende Schrift
//  frage: Die Frage die an den Benutzer gestellt werden soll
//  left: Die linke Antwort
//  right: Die rechte Antwort
//  leftAk: Ein Zeiger auf eine Funktion die beim whlen der Linken Antwort aufgerufen wird
//  rightAk: Ein Zeiger auf eine Funktion die beim whlen der Rechten Antwort aufgerufen wird
//  abbruchAk: Ein Zeiger auf eine Funktion die beim Schlieen des Fensters aufgerufen wird
//  maxSize: Die Bildschirmgre in Pixeln
Frage::Frage( TextRenderer *tr, char *frage, char *left, char *right, std::function< void() > leftAk, std::function< void() > rightAk, std::function< void() > abbruchAk, Punkt maxSize )
    : Dialog( tr )
{
    Text *tmp = new Text( frage );
    tr->setSchriftSize( 12 );
    tr->textFormatieren( tmp, 300 );
    int br = tr->getTextBreite( tmp->getText() );
    int h = tr->getTextHeight( tmp->getText() );
    setSize( br + 12, h + 63 );
    setPosition( maxSize / 2 - getSize() / 2 );
    
    TextFeld *text = initTextFeld( 5, 5, br, h, tr->zSchrift(), TextFeld::Style::Text, tmp->getText() );
    addMember( text );
    tmp->release();
    Knopf *r = initKnopf( br - 94, h + 22, 100, 20, tr->zSchrift(), Knopf::Style::Normal, right );
    addMember( r );
    Knopf *l = initKnopf( br - 199, h + 22, 100, 20, tr->zSchrift(), Knopf::Style::Normal, left );
    addMember( l );

    bool *verl = &verlassen;

    r->setMausEreignis( [ verl, rightAk ]( void *param, void *obj, MausEreignis me ) -> bool
    {
        if( me.id == ME_RLinks && !me.verarbeitet && !*verl )
        {
            *verl = 1;
            if( rightAk )
                rightAk();
        }
        return 1;
    } );
    l->setMausEreignis( [ verl, leftAk ]( void *param, void *obj, MausEreignis me ) -> bool
    {
        if( me.id == ME_RLinks && !me.verarbeitet && !*verl )
        {
            *verl = 1;
            if( leftAk )
                leftAk();
        }
        return 1;
    } );
    setClosingMe( [ verl, abbruchAk ]( void *param, void *obj, MausEreignis me ) -> bool
    {
        if( me.id == ME_RLinks && !me.verarbeitet && !*verl )
        {
            *verl = 1;
            if( abbruchAk )
                abbruchAk();
        }
        return 1;
    } );
}

Frage::~Frage()
{}
