#pragma once

#include "../RightTools.h"
#include "../../../../Spiel/Karte/Strukturen.h"
#include "../../../Karte/EditorKarte.h"
#include "../../Dialogs/ResourceDialog.h"
#include <Liste.h>
#include <M2DVorschau.h>

namespace Editor
{
    class ObjektTool : public RightTool
    {
    private:
        AuswahlListe *objekte;
        Knopf *neuesObjekt;
        M2DVorschau *model;
        Knopf *changeModel;
        Knopf *changeTextur;
        TextFeld *stabilittT;
        TextFeld *stabilitt;
        TextFeld *energieT;
        TextFeld *energie;
        TextFeld *energieRadiusT;
        TextFeld *energieRadius;
        TextFeld *reparaturT;
        TextFeld *reparatur;
        TextFeld *akkuLeistungT;
        TextFeld *akkuLeistung;
        AuswahlBox *team;
        KontrollKnopf *verwundbar;
        KontrollKnopf *beweglich;
        KontrollKnopf *collision;
        KontrollKnopf *laserCollision;
        KontrollKnopf *neutral;
        KontrollKnopf *erfahrung;
        Knopf *speichern;
        Knopf *lschen;
        KarteDaten *daten;
        Schrift *schrift;
        Text modelPath;
        Text texturPath;
        ResourceDialog *dialog;
        ResourceDialog *dialog2;
        Punkt screenSize;
        Critical cs;

    public:
        ObjektTool( Schrift *zSchrift, KarteDaten *daten );
        ~ObjektTool();
        void doMausEreignis( MausEreignis &me ) override;
        void doTastaturEreignis( TastaturEreignis &te ) override;
        bool tick( double tickVal ) override;
        void render( Bild &rObj ) override;
        void renderDialogs( Bild &rObj ) override;
        void selectObject( int id );
    };
}