#pragma once

#include <Bild.h>

using namespace Framework;

class ActiveSkill
{
protected:
    struct SkillDataSave
    {
        bool active;
        double time;
    } current, last;
    double maxTime;
    int ref;
    double reloadTimeFactor;
    Bild *bild;

    // skill bonus added when active
    double beschleunigungBonus;
    double reparaturBonus;
    double laserIntensittBonus;
    double laserEffizienzBonus;
    double akkuLeistungBonus;
    double maxEnergieBonus;
    double maxStabilittBonus;
    double laserTempoBonus;
    double wendigkeitBonus;
    double antriebEffizienzBonus;
    double energieSchildBonus;
    double energieSchildEffizienzBonus;

    // skil multiplier when active
    double beschleunigungFactor;
    double reparaturFactor;
    double laserIntensittFactor;
    double laserEffizienzFactor;
    double akkuLeistungFactor;
    double maxEnergieFactor;
    double maxStabilittFactor;
    double laserTempoFactor;
    double wendigkeitFactor;
    double antriebEffizienzFactor;
    double energieSchildFactor;
    double energieSchildEffizienzFactor;

public:
    ActiveSkill( Bild *bild );
    ~ActiveSkill();
    void save();
    void load();
    void tick( double time );
    void render( int x, int y, Bild &zRObj );
    bool isActive() const;
    void activate();
    void reset();

    double getBeschleunigungBonus();
    double getReparaturBonus();
    double getLaserIntensittBonus();
    double getLaserEffizienzBonus();
    double getAkkuLeistungBonus();
    double getMaxEnergieBonus();
    double getMaxStabilittBonus();
    double getLaserTempoBonus();
    double getWendigkeitBonus();
    double getAntriebEffizienzBonus();
    double getEnergieSchildBonus();
    double getEnergieSchildEffizienzBonus();

    double getBeschleunigungFactor();
    double getReparaturFactor();
    double getLaserIntensittFactor();
    double getLaserEffizienzFactor();
    double getAkkuLeistungFactor();
    double getMaxEnergieFactor();
    double getMaxStabilittFactor();
    double getLaserTempoFactor();
    double getWendigkeitFactor();
    double getAntriebEffizienzFactor();
    double getEnergieSchildFactor();
    double getEnergieSchildEffizienzFactor();

    ActiveSkill *getThis();
    ActiveSkill *release();
};

class SpeedBoost : public ActiveSkill
{
public:
    SpeedBoost( Bild *bild );
};

class ShieldBoost : public ActiveSkill
{
public:
    ShieldBoost( Bild *bild );
};